/******************************************************************************* 
 * Copyright (c) 2007 Red Hat, Inc.
 * Distributed under license by Red Hat, Inc. All rights reserved.
 * This program is made available under the terms of the
 * Eclipse Public License v1.0 which accompanies this distribution,
 * and is available at http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Red Hat, Inc. - initial API and implementation
 ******************************************************************************/
package org.jboss.tools.jsf.vpe.richfaces.template.util;

/**
 * contain rich faces tags and general attributes
 * 
 * @author Sergey Dzmitrovich
 * 
 */
public class RichFaces {

	private RichFaces() {
	}

	/**
	 * jsf tags which are used with richFaces
	 */
	public static final String TAG_COLUMN = "column"; //$NON-NLS-1$
	public static final String TAG_FACET = "facet"; //$NON-NLS-1$

	public static final String ATTR_NAME = "name"; //$NON-NLS-1$
	public static final String ATTR_STYLE = "style"; //$NON-NLS-1$
	public static final String ATTR_WIDTH = "width"; //$NON-NLS-1$
	public static final String ATTR_VALUE = "value"; //$NON-NLS-1$
	public static final String ATTR_INPUT_SIZE = "inputSize"; //$NON-NLS-1$
	public static final String ATTR_INPUT_CLASS = "inputClass"; //$NON-NLS-1$
	public static final String ATTR_INPUT_STYLE = "inputStyle"; //$NON-NLS-1$
	public static final String ATTR_ROW_CLASSES = "rowClasses"; //$NON-NLS-1$
	public static final String ATTR_COLUMN_CLASSES = "columnClasses"; //$NON-NLS-1$
	public static final String ATTR_CONTROLS_TYPE = "controlsType"; //$NON-NLS-1$
	public static final String ATTR_SHOW_BUTTON_LABELS = "showButtonLabels"; //$NON-NLS-1$

}
